# Bruch-einfachere-Addition.py
class Bruch:
    def __init__(self, zaehler, nenner):
        self.zaehler=zaehler
        self.nenner=nenner

    def zeige(self):
        print( "(", self.zaehler, "/" , self.nenner, ")" )

    def gib(self):
        return self.zaehler, self.nenner

    def gibString(self):
        return str(self.zaehler)+  " / " + str(self.nenner)

    def multipliziere(self, b):
        temp=Bruch(self.zaehler*b.zaehler, self.nenner*b.nenner)
        temp.kuerze()
        return temp
    
    def dividiere(self, b):
        if b.zaehler!=0:
            temp=Bruch(self.zaehler*b.nenner, self.nenner*b.zaehler)
            temp.kuerze()
        else: temp=self
        return temp

    def kuerze(self):
        # zaehler kann 0 sein:
        if self.zaehler==0: self.nenner=1
        else:
            # zaehler kann negativ sein!
            teiler=ggT(abs(self.zaehler),self.nenner)
            self.zaehler=self.zaehler/teiler
            self.nenner=self.nenner/teiler
        
    # gleichnamig ist nur ein Problem ohne Langzahlarithmetik
    def addiere(self, b):
        temp=Bruch(self.zaehler*b.nenner+b.zaehler*self.nenner,self.nenner*b.nenner)
        temp.kuerze()
        return temp
    
    def subtrahiere(self, b):
        temp=Bruch(self.zaehler*b.nenner-b.zaehler*self.nenner,self.nenner*b.nenner)
        temp.kuerze()
        return temp
        
# Klassenunabhaengige Funktionen
def ggT(a, b):
    if a<b: a,b=b,a
    rest=a%b
    while rest>0:
        a=b
        b=rest
        rest=a%b
    return b

